#
# Copyright (c) 2003 Linuxant inc.
# Copyright (c) 2001-2003 Conexant Systems, Inc.
#
# NOTE: The use and distribution of this software is governed by the terms in
# the file LICENSE, which is included in the package. You must read this and
# agree to these terms before using or distributing this software.
# 

# set _target_kernel to generic if it wasn't defined on the command-line
%if %{expand:%{?_target_kernel:0}%{!?_target_kernel:1}}
%define _target_kernel generic
%endif

%if "%{_target_kernel}" == "generic"
%define ver      0.99lnxtbeta03042700
%define rel      1
%define automrecomp 1
%else
%define ver      0.99lnxtbeta03042700k%(eval echo %{_target_kernel} | sed 's/-/_/g')
%define rel      1%{_target_distro}
%define automrecomp 0
%endif

%define hcftarget   hcfpci
%define debug_build 127

# Note that this is NOT a relocatable package

# Even though newer versions of RPM provide definitions for these,
# we must still accomodate the older ones
%define prefix   /usr
%define etcdir   /etc
%define libdir   %{prefix}/lib
%define sbindir  %{prefix}/sbin
%define bindir   %{prefix}/bin

Summary:   Conexant HCF controllerless modem driver for Linux
Name:      %{hcftarget}modem
ExclusiveOS: Linux
%if "%{_target_kernel}" == "generic"
ExclusiveArch: athlon i686 i586 i486 i386
%else
ExclusiveArch: %{_target_cpu}
%endif
Version:   %ver
Release:   %rel
Vendor:	   Linuxant
Copyright: Copyright (c) 2003 Linuxant inc. All rights reserved.
Group:     System Environment/Kernel
Source:    %{hcftarget}modem-0.99lnxtbeta03042700.tar.gz
Source2:   100498D_RM_HxF_Released.pdf
URL:       http://www.linuxant.com/drivers/hcf
BuildRoot: %{_tmppath}/%{hcftarget}modem-%{PACKAGE_VERSION}-root
Packager:  Linuxant
Requires:  pciutils
Conflicts: hcflinmodem
Autoreq:   0

%if "%{_target_kernel}" == "generic"
%package doc
Group:     Documentation
Summary:   Documentation for Conexant HCF controllerless modems
%endif

%description
Conexant HCF controllerless modem driver for Linux

Copyright (c) 2003 Linuxant inc.
Copyright (c) 2001-2003 Conexant Systems, Inc.

1.   Permitted use. Redistribution and use in source and binary forms,
without modification, are permitted under the terms set forth herein.

2.   Disclaimer of Warranties. LINUXANT, ITS SUPPLIERS, AND OTHER CONTRIBUTORS
MAKE NO REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
LINUXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD
TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.

This software has not been formally tested, and there is no guarantee that
it is free of errors including, but not limited to, bugs, defects,
interrupted operation, or unexpected results. Any use of this software is
at user's own risk.

3.   No Liability.

(a) Linuxant, its suppliers, or contributors shall not be responsible for
any loss or damage to users, customers, or any third parties for any reason
whatsoever, and LINUXANT, ITS SUPPLIERS OR CONTRIBUTORS SHALL NOT BE LIABLE
FOR ANY ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR
CONSEQUENTIAL (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

(b) User agrees to hold Linuxant, its suppliers, and contributors harmless
from any liability, loss, cost, damage or expense, including attorney's fees,
as a result of any claims which may be made by any person, including
but not limited to User, its agents and employees, its customers, or
any third parties that arise out of or result from the manufacture,
delivery, actual or alleged ownership, performance, use, operation
or possession of the software furnished hereunder, whether such claims
are based on negligence, breach of contract, absolute liability or any
other legal theory.

4.   Notices. User hereby agrees not to remove, alter or destroy any
copyright, trademark, credits, other proprietary notices or confidential
legends placed upon, contained within or associated with the Software,
and shall include all such unaltered copyright, trademark, credits,
other proprietary notices or confidential legends on or in every copy of
the Software.

5.   Reverse-engineering. User hereby agrees not to reverse engineer,
decompile, or disassemble the portions of this software provided solely
in object form, nor attempt in any manner to obtain their source-code.

6.   Redistribution. Redistribution of this software is permitted only
for non-beta, officially released versions. Redistribution of versions
marked "beta" or "lnxtbeta" requires explicit written approval from
Linuxant.

%if "%{_target_kernel}" == "generic"
%description doc
This package contains the documentation for Conexant HCF controllerless
modems.
%endif

%prep
%setup -q -n %{hcftarget}modem-0.99lnxtbeta03042700

%build
make --quiet --no-print-directory all
%if "%{_target_kernel}" == "generic"

cp %{SOURCE2} .

%else

%if "%{_target_distro}" == "rh"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/%{_target_distro}/linux-%{_target_kernel} DISTRO_CFLAGS="-D__BOOT_KERNEL_H_ -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=1 -D__MODULE_KERNEL_%{_target_cpu}=1" HCF_MODS_DIR=binaries/%{_target_cpu}/%{_target_distro}/linux-%{_target_kernel} clean all modules_install || exit $?
	fi
) || exit $?
%endif

%if "%{_target_distro}" == "mdk"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/%{_target_distro}/linux-%{_target_kernel} DISTRO_CFLAGS="-D__BOOT_KERNEL_H_ -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=1 -D__MODULE_KERNEL_%{_target_cpu}=1" HCF_MODS_DIR=binaries/%{_target_cpu}/%{_target_distro}/linux-%{_target_kernel} clean all modules_install || exit $?
		ln -s i586 binaries/i686
		ln -s i586 binaries/athlon
	fi
) || exit $?
%endif

%if "%{_target_distro}" == "suse"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/%{_target_distro}/linux-%{_target_kernel} HCF_MODS_DIR=binaries/%{_target_cpu}/%{_target_distro}/linux-%{_target_kernel} clean all modules_install || exit $?
%if "%{_target_cpu}" == "i586"
		for a in i686 athlon; do
%else
		for a in i386 i486 i586 i686 athlon; do
%endif
			[ -e binaries/$a ] || ln -s %{_target_cpu} binaries/$a
		done
	fi
) || exit $?
%endif

%endif

%install
rm -rf $RPM_BUILD_ROOT

make --quiet --no-print-directory ROOT=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT

%files

%defattr(0555, root, root, 755)

%{sbindir}/%{hcftarget}config
%{sbindir}/%{hcftarget}stop

%defattr(0444, root, root, 755)
%dir %{etcdir}/%{hcftarget}
%dir %{etcdir}/%{hcftarget}/inf
%config %{etcdir}/%{hcftarget}/inf/*.inf
%config %{etcdir}/%{hcftarget}/inf/*.cty
%dir %{libdir}/%{hcftarget}
%doc %{libdir}/%{hcftarget}/LICENSE
%dir %{libdir}/%{hcftarget}/modules
%doc %{libdir}/%{hcftarget}/modules/COPYING
%{libdir}/%{hcftarget}/modules/binaries

%if %{automrecomp}
%config %{libdir}/%{hcftarget}/config.mak
%{libdir}/%{hcftarget}/imported
%attr(755, root, root) %{libdir}/%{hcftarget}/modules/*.sh
%{libdir}/%{hcftarget}/modules/[mM]akefile
%{libdir}/%{hcftarget}/modules/common.mak
%{libdir}/%{hcftarget}/modules/*.c
%{libdir}/%{hcftarget}/modules/*.h
%dir %{libdir}/%{hcftarget}/modules/osspec
%{libdir}/%{hcftarget}/modules/osspec/[mM]akefile
%{libdir}/%{hcftarget}/modules/osspec/*.c
%dir %{libdir}/%{hcftarget}/modules/osspec/include
%{libdir}/%{hcftarget}/modules/osspec/include/*.h
%endif

%doc BUGS CHANGES CREDITS FAQ INSTALL LICENSE README

%pre
if [ -e "%{libdir}/%{hcftarget}" ]; then
	echo "Removing old %{libdir}/%{hcftarget}"
	rm -rf "%{libdir}/%{hcftarget}"
else
	exit 0
fi

%post
%if ! %{automrecomp}
HCF_AUTOCONFIG=true
%endif
if [ -n "${HCF_AUTOCONFIG}" -a -z "${HCF_NOAUTOCONFIG}" ]; then
	%{sbindir}/%{hcftarget}config --auto
	exit $?
else
	echo "To complete the installation and configuration of your HCF modem,"
	echo "please run \"%{hcftarget}config\" (or \"%{sbindir}/%{hcftarget}config\")"
	exit 0
fi

%preun
if [ -z "${HCF_NOAUTOCONFIG}" ]; then
	%{sbindir}/%{hcftarget}config --remove
else
	exit 0
fi

%if "%{_target_kernel}" == "generic"
%files doc
%doc *.pdf
%endif

# This must be last since the file CHANGES is automatically appended
%changelog

* Sun Apr 27 2003 Marc Boucher
	- Released hcfpcimodem-0.99lnxtbeta03042700.
	- Released hcfusbmodem-0.99lnxtbeta03042703ppc.
	(see FAQ if you are looking for an x86 version of hcfusbmodem driver)

* Sun Apr 27 2003 Marc Boucher
	- modules/osspec/osnvm.c: fixed size and byte-ordering issues
	in NVM_WriteKey(). This caused NO DIALTONE problems on PPC.
	(Thanks to Benjamin Herrenschmidt for helping track down this issue)
	- makefile, hcfmodem.spec.in: changes to build packages for newer
	SuSE versions with i586 arch and athlon kernels.
	- modules/kernelcompiler.sh: fixed SuSE 8.2 issue.
	- scripts/hcfconfig.in: fix link problem in create_temp_kernel_tree().
	- FAQ: updated.

* Sat Apr 26 2003 Marc Boucher
	- imported/hcfengine.O: fixed endianness issue.

* Fri Apr 25 2003 Marc Boucher
	- modules/serial_hcf.c: added support for hard break signal generation.

* Fri Apr 25 2003 Marc Boucher
	- Merged USB version with latest code from Conexant.

* Fri Apr 25 2003 Marc Boucher
	- Released hcfpcimodem-0.99lnxtbeta03042501.

* Fri Apr 25 2003 Marc Boucher
	- imported/hcfengine.O: applied CiDetector workaround for
	"DownloadDp failure, conf=0xff - bad crc got=0xff,wanted=0x53" problem
	affecting SmartDAA boards after DTR transitions or hangups.

* Fri Apr 25 2003 Marc Boucher
	- Released hcfpcimodem-0.99lnxtbeta03042500.

* Thu Apr 24 2003 Marc Boucher
	- modules/osspec/osservices.c: support recursive locks and critical
	sections.
	- modules/mod_osspec.c: added OsCriticalSection functions and ulLogThread.
	- modules/osspec/osnvm.c: increased CFILE_BUFFER_SIZE to fix
	parsing of long PoundUD lines causing growing inf file phenomenon,
	and modified NVM_WriteKey() to limit line length.
	- scripts/hcfconfig.in: improved dump_diagnostics() and added --noprobe
	option. get_current_country_from_inf(): ignore duplicate entries.
	- inf/hcfv90_linux.inf: added PCI ID 141A:1035 for
	Apache Micro Peripherals modem.
	- modules/osspec/include/oscompat.h: OsContextAllowsSleeping().
	- FAQ: updated.

* Fri Apr 18 2003 Marc Boucher
	- Released hcfpcimodem-0.99lnxtbeta03041800.

* Fri Apr 18 2003 Marc Boucher
	- imported/hcfengine.O: don't use stream/session locks for now.
	- imported/hcfengine.O: increased buffer size for AT#UG (lastcallstatus).
	- modules/serial_hcf.c: hcf_get_lastcallstatus(): use length and check
	offset.

* Wed Apr 16 2003 Marc Boucher
	- Released hcfpcimodem-0.99lnxtbeta03041600.

* Wed Apr 16 2003 Marc Boucher
	- FAQ: major update.
	- imported/hcfengine.O: merged with latest code from Conexant.
	- makefile: added rule to sign rpm packages.
	- modules/osspec/osservices.c: fixed important race in mdmthrd().

* Wed Apr 16 2003 Marc Boucher
	- Added pre-built binary packages for the following
	distributions/kernel versions:
		Mandrake 9.1 linux-2.4.21-0.13mdk
		Mandrake 9.0 linux-2.4.19-32mdk
		RedHat 9 linux-2.4.20-8 and -9
		RedHat 8.0 linux-2.4.18-27.8.0
		SuSE 8.2 2.4.20-4GB
	- modules/kernelcompiler.sh: updated.

* Wed Apr 16 2003 Marc Boucher
	- modules/osspec/osservices.c: compatibility changes for
	RedHat 9 and newer 2.5 kernels.

* Wed Apr 16 2003 Marc Boucher
	- Now officially maintained and distributed by Linuxant.

* Tue Dec 31 2002 Marc Boucher
	- Released hcfpcimodem-0.99mbsibeta02123100.

* Tue Dec 31 2002 Marc Boucher
	- Removed prefix from AT+FCLASS=? response, which crept in again
	causing problems with HylaFAX.
	(Thanks to Seshareddy Kamireddi for reporting this)

* Wed Dec 25 2002 Marc Boucher
	- Released hcfpcimodem-0.99mbsibeta02122500.

* Wed Dec 25 2002 Marc Boucher
	- imported/hcfengine.O: merged with latest code from Conexant.

* Wed Dec 25 2002 Marc Boucher
	- makefile: added Mandrake 9.0 linux-2.4.19-19mdk kernel.
	- makefile: added RedHat 2.4.18-19.7.x and 2.4.18-19.8.0 kernels.

* Sun Nov 03 2002 Marc Boucher
	- Released hcfpcimodem-0.98mbsibeta02110301.

* Sun Nov 03 2002 Marc Boucher
	- modules/kernelcompiler.sh: use gcc 3 to build modules for
	SuSE's 2.4.19-4GB kernel.

* Sun Nov 03 2002 Marc Boucher
	- Released hcfpcimodem-0.98mbsibeta02110300.

* Sun Nov 03 2002 Marc Boucher
	- makefile: added RedHat 2.4.18-17.7.x and 2.4.18-17.8.0 kernels.
	- makefile: added SuSE 2.4.19-4GB kernel.
	- modules/kernelcompiler.sh: use gcc 3 to build modules for
	RedHat's 2.4.18-17.8.0 kernel.
	- modules/serial_hcf.c: properly test COMCTRL_MONITOR_POUND_UG_SUPPORTED.
	- scripts/hsfconfig.in: put module configuration in /etc/modules.d and
	run update-modules if present (for gentoo).
	- imported/hcfengine.O: limit voice (+FCLASS=8) to recent datapumps (73DP)
	for now.

* Wed Oct 16 2002 Marc Boucher
	- Released hcfpcimodem-0.98mbsibeta02101002.

* Wed Oct 16 2002 Marc Boucher
	- scripts/hcfconfig.in: optimized auto_find_inf() to compensate for
	RedHat 8.0 gawk slowness.

* Fri Oct 11 2002 Marc Boucher
	- Released hcfpcimodem-0.98mbsibeta02101001.

* Fri Oct 11 2002 Marc Boucher
	- modules/kernelcompiler.sh: use gcc 3 to build modules for
	RedHat's 2.4.18-14 kernel.

* Thu Oct 10 2002 Marc Boucher
	- Released hcfpcimodem-0.98mbsibeta02101000.

* Thu Oct 10 2002 Marc Boucher
	- makefile: added RedHat 8.0 linux-2.4.18-14 kernel.

* Mon Sep 30 2002 Marc Boucher
	- makefile: added Mandrake 9.0 linux-2.4.19-16mdk kernel and
	removed obsolete SuSE 2.4.4-4GB kernel.
	- modules/kernelcompiler.sh: added gcc-2.96 (for Mandrake 9) and
	RPM_BUILD_ROOT support.
	- inf/hcf_linux.cty: Changed INTCODE for SWEDEN from 009 to 00.
	(Thanks to Anders Helmersson)

* Sun Sep 29 2002 Marc Boucher
	- makefile: tardist: changed way tar.gz files are generated to
	avoid gzip "decompression OK, trailing garbage ignored" messages.

* Mon Sep 23 2002 Marc Boucher
	- modules/osspec/osservices.c: minor adjustments for 2.5 compatibility.
	- modules/serial_core.c: uart_register_driver(): set driver_name
	to drv->owner->name for proper /proc/tty/driver/ naming;
	renamed HCFSERIAL_INCLUDE_CORE to CNXTSERIAL_INCLUDE_CORE throughout.

* Mon Sep 02 2002 Marc Boucher
	- Released hcfpcimodem-0.98mbsibeta02090200.
	- Released hcfusbmodem-0.98mbsibeta02090200ppc.

* Mon Sep 02 2002 Marc Boucher
	- imported/hcfengine.O: added fix for hangup problems & fax workaround.
	- inf/: ATI3 string changed to use new driver (target) name, restored
	previous fAnalogSpeaker setting in OEM FLAGS.
	- scripts/hcfconfig.in: fixed awk strtonum issue. (Thanks to Edd Dumbill)
	- scripts/hcfconfig.in: added @HCFTARGET@ inf substitution keyword.

* Sun Sep 01 2002 Marc Boucher
	- Released hcfpcimodem-0.98mbsibeta02090100.
	- Released hcfusbmodem-0.98mbsibeta02090100ppc.

* Sat Aug 31 2002 Marc Boucher
	- imported/hcfengine.O: various workarounds.
	- makefile: added Mandrake 2.4.18-8.1mdk kernel.
	- modules/osspec/osservices.c: fixed more potential race conditions
	and thread termination problems.
	- modules/osspec/{osusb.c,include/oscompat.h}: applied 2.4.20-pre
	compatibility patch from Benjamin Herrenschmidt.
	- FAQ: updated.

* Sun Aug 25 2002 Marc Boucher
	- makefile: added RedHat 2.4.18-10 kernel.
	- modules/osspec/include/oscompat.h: added kernel stack checker.
	- modules/osspec/osservices.c: mdmthrd startup/shutdown improvements.

* Wed Aug 21 2002 Marc Boucher
	- imported/hcfengine.O: merged with latest code from Conexant.
	- Integrated voice (AT+FCLASS=8) support.
	- Added modules/kernelcompiler.sh, a small script which tries
	to guess which compiler should be used to build kernel modules.
	- modules/common.mak: use kernelcompiler.sh to determine default CC
	- modules/common.mak, INSTALL: added notes about KERNELSRC for
	Debian 3.0 users.
	- modules/osspec/osnvm.c: NVM_Write() now returns COM_STATUS_SUCCESS
	for unrecognized codes.

* Sun Jul 21 2002 Marc Boucher
	- makefile: added RedHat 2.4.9-34 and 2.4.18-5 kernels.
	- Updated BUGS file.

* Thu Jul 18 2002 Marc Boucher
	- modules/serial_hcf.c: retry OsUsbGetInstance(0) if it fails.
	- modules/osspec/osusb.c: removed OsSleep(250) after
	pmac_call_feature(PMAC_FTR_MODEM_ENABLE, NULL, 0, 1);
	(Thanks to Benjamin Herrenschmidt for both fixes)

* Fri Jul 05 2002 Marc Boucher
	- Released hcfpcimodem-0.97mbsibeta02070500.

* Fri Jul 05 2002 Marc Boucher
	- imported/hcfengine.O: merged with latest code from Conexant.
	- Initial support for multiple machine architectures.
	- modules/osspec/osservices.c: use cmpxchg() as OsAtomicCompareAndSwap()
	if available.
	- modules/osspec/osservices.c: implemented dedicated kernel thread,
	replacing use of tq_scheduler and schedule_task(). This should address
	problems under earlier 2.2 kernels.
	- modules/osspec/osservices.c: if called in interrupt context,
	OsSleep() now complains and aborts.
	- modules/osspec/osnvm.c: do not generate carriage returns.
	- scripts/hcfconfig.in: added crude big-endian inf file conversion hack,
	and support for GNU awk invocation as gawk.

* Tue Jun 25 2002 Marc Boucher
	- Released hcfpcimodem-0.96mbsibeta02062500.

* Tue Jun 25 2002 Marc Boucher
	- Renamed PCI driver package to hcfpcimodem in preparation for release
	of hcfusbmodem. Most pathnames and script prefixes also changed from
	'hcf' to 'hcfpci'.
	- Silenced HwHdlcWrite: .. HW_HDLC_NONE messages.
	- modules/osspec/include/oscompat.h: get rid of non-standard min/max
	- modules/common.mak: added -Wno-multichar to CFLAGS.
	- inf/hcfv90_linux.inf: added PCI ID 158b:0015 for
	Allied Data Technologies modem (thanks to Dave Rodgman)

* Tue Jun 18 2002 Marc Boucher
	- Released hcflinmodem-0.95mbsibeta02061800.

* Tue Jun 18 2002 Marc Boucher
	- Eliminated unwanted debug messages.
	- OSTermPowerManagement(): use pm_unregister() under 2.4,
	pm_unregister_all() only once under 2.2.

* Mon Jun 17 2002 Marc Boucher
	- Released hcflinmodem-0.95mbsibeta02061700.

* Sun Jun 16 2002 Marc Boucher
	- imported/hcfengine.O: merged with latest code from Conexant.
	- Added preliminary power-management support.
	- More FAX/HDLC workarounds.
	- modules/osspec/osservices.c: OsSleep() and timer code tweaking.

* Thu Jun 13 2002 Marc Boucher
	- Released hcflinmodem-0.94mbsibeta02061300.

* Thu Jun 13 2002 Marc Boucher
	- Implemented workarounds for HW HDLC problems affecting fax mode.
	Class 1 FAX reception and transmission should now work.

* Tue Jun 11 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02061100.

* Tue Jun 11 2002 Marc Boucher
	- Added RIPTIDE HCF modem support.
	- inf/, scripts/hcfconfig.in: small restructuration; use hcf_linux.cty
	as default cty file unless one corresponding to selected inf file exists.
	- makefile, hcflinmodem.spec.in: don't include big pdf file in tar pkgs.

* Mon Jun 10 2002 Marc Boucher
	- scripts/hcfconfig.in: choose_pcicomctrl() should also list
	PCI serial controllers to catch older HCF modems.
	- makefile, hcflinmodem.spec.in: better error propagation for RPM builds.

* Sun Jun 02 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02060200.

* Sun Jun 02 2002 Marc Boucher
	- Restructured packaging once again to improve consistency with linux
	distribution practices and further reduce space consumption.

* Sat Jun 01 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02060100.

* Sat Jun 01 2002 Marc Boucher
	- modules/serial_hcf.c: hcf_tx_ready() should ignore hcf_evt_txempty
	for now since atparser doesn't update STATUS_ATDTE_TX_CHAR for first
	characters ('A', 'T') after +++.
	- modules/osspec/osstdio.c: various enhancements to OsFOpen().

* Fri May 31 2002 Marc Boucher
	- Removed extraneous prefixes from T.31 fax command responses.
	- Added temporary workarounds to prevent crashes and freezes in fax mode,
	which doesn't work yet but soon will.

* Tue May 28 2002 Marc Boucher
	- modules/serial_core.c: replaced MINOR() with minor() for 2.5.x and
	added missing spin_lock_init(&info->lock) to uart_get().
	- modules/osspec/include/oscompat.h: ensure minor() is defined.

* Sun May 26 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02052600.

* Sun May 26 2002 Marc Boucher
	- Restructured distribution-specific packaging to include
	only needed kernel module binaries without unnecessary source.
	This reduces package sizes and download times. Only the generic
	packages now contain source code providing hcfconfig the ability
	to re-link the kernel modules on-the-fly.
	hcfconfig --auto is once again executed automatically during
	installation of distribution-specific RPMs.
	- Updated README, INSTALL and BUGS documentation files.
	- modules/osspec/: minor cleanups

* Thu May 23 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02052300.

* Thu May 23 2002 Marc Boucher
	- scripts/hcfconfig.in: remove old /dev/modem after configuring devfs.

* Tue May 21 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02052101.

* Tue May 21 2002 Marc Boucher
	- modules/makefile: Added binary module support for SuSE 8.0 (2.4.18-4GB)

* Tue May 21 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02052100.

* Mon May 20 2002 Marc Boucher
	- scripts/hcfconfig.in: Improved devfs configuration to hopefully solve
	automatic module loading/device node visibility issues.
	- modules/makefile: Added binary module support for RedHat 7.3
	- modules/makefile, common.mak: implemented workaround for
	obscure make bug causing compilation to fail with the error
	"make: expand.c:489: allocated_variable_append:
	Assertion `current_variable_set_list->next != 0' failed."
	- inf/*.cty: use more generic relay parameters.

* Sun May 19 2002 Marc Boucher
	- Released hcflinmodem-0.93mbsibeta02051900.

* Sat May 18 2002 Marc Boucher
	- Added preliminary support for 127A:100x (71DP) devices.
	- Added preliminary support for 14F1:1813 and 1815 LAN/Modem combo.
	- Revamped and updated INF files.
	- scripts/hcfconfig.in: proper ISO-3166 country map entries for
	ARGENTINA, BRAZIL, CZECH_REPUBLIC, and NETHERLANDS.
	- modules/osspec/osresour.c: rewrote OSGetPCIDeviceResources()
	- modules/osspec/osnvm.c: added CALLERID2, CALLWAITING_PARMS, V92_CONTROL,
	FLAGS2, CW, PIG, and MOH.

* Mon May 06 2002 Marc Boucher
	- Released hcflinmodem-0.92mbsibeta02050600.

* Mon May 06 2002 Marc Boucher
	- scripts/hcfconfig.in: check_unsupported(): some 127a:102x devices
	actually work.
	- modules/osspec/include/oscompat.h: fixed memcpy issue for 2.2 users.

* Sun May 05 2002 Marc Boucher
	- Released hcflinmodem-0.92mbsibeta02050500.

* Sun May 05 2002 Marc Boucher
	- Changed ttyHCF0 device name to ttySHCF0 for compatibility with wvdial.

* Fri Apr 26 2002 Marc Boucher
	- modules/osspec/include/osuniqredef.h: added to solve name collision
	problem with HSF and other modules.

* Fri Apr 26 2002 Marc Boucher
	- scripts/hcfconfig.in: added OSKERNTYPE, which is set to the type
	of kernel installed, not the architecture.
	- modules/makefile: add i386 to REDHAT_MACHINES to accomodate people
	still running i386 kernels and link-identical-binaries to save space..

* Wed Apr 25 2002 Marc Boucher
	- Released hcflinmodem-0.91mbsibeta02042500.

* Wed Apr 24 2002 Marc Boucher
	- imported/hcfengine.O: merged in new Conexant modem code, added
	SmartDAA support.
	- scripts/hcfconfig.in: remove SmartDAA devices from check_unsupported().
	- inf/: reorganized inf files, removed unnecessary sections,
	added SmartDAA versions.
	- modules/serial_hcf.c: handle new-style COMCTRL_EVT_RINGS events.

* Mon Apr 22 2002 Marc Boucher
	- scripts/hcfconfig.in: re-enabled creation of /dev/modem symlink
	- Released hcflinmodem-0.9mbsibeta02042201.

* Mon Apr 22 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02042200.

* Sun Apr 21 2002 Marc Boucher
	- modules/serial_hcf.c: Added /proc/driver/hcf/0/lastcallstatus and
	loglastcallstatus parameter, which when set to a non-zero value will
	make the driver automatically log the last call status (AT#UG) info.
	- modules/osspec/osnvm.c: Use AT&D2 by default.
	- imported/hcfengine.O: silenced various debug messages confusing users.
	- scripts/hcfconfig.in: added check_unsupported(), workaround for
	bash's limited printf builtin and other small usability improvements.
	- modules/common.mak: changed default KERNELSRC to match hcfconfig.

* Sat Apr 20 2002 Marc Boucher
	- modules/osspec/osstdio.c: if f_op->llseek is NULL, call default_llseek.
	(Thanks to Gratiniano S. de Haro for reporting this problem)
	- scripts/hcfconfig.in: cut down size of default --dumpdiag output.

* Wed Apr 13 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02041300.

* Wed Apr 12 2002 Marc Boucher
	- modules/makefile: revamped directory structure for binaries and added
	several mandrake kernels.
	- makefile: add missing bracket to RPMTOPDIRDEFINED test.
	- scripts/hcfconfig.in: create /lib/modules/.../misc directory if it
	doesn't exist and add build kernel-source check.
	- scripts/hcfconfig.in: really fix broken pipe messages in get_inf_section

* Wed Apr 05 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02040500.

* Wed Apr 03 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02040300.

* Wed Apr 03 2002 Marc Boucher
	- scripts/hcfconfig.in: add check for binary modules with OSKERNVERS_NODASH.
	- modules/osspec/osservices.c: OsSleep() workaround to prevent crashes
	on < 2.2.20 kernels.

* Tue Mar 26 2002 Marc Boucher
	- hcflinmodem.spec.in, makefile: add distribution-specific
	packages containing module binaries for default kernels.

	- modules/common.mak: add DISTRO_CFLAGS

	- modules/makefile: add rules to build binaries for mainstream
	distributions.

* Sun Mar 24 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02032400.

* Sun Mar 24 2002 Marc Boucher
	- modules/osspec/osnvm.c: Added check for OsFOpen() return value.
	- Improved test for awk strtonum() workaround.
	(Thanks to Gratiniano S. de Haro)

* Fri Mar 08 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02030801.

* Fri Mar 08 2002 Marc Boucher
	- scripts/hcfconfig.in: workaround for awks that don't support strtonum().

* Fri Mar 08 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02030800.

* Fri Mar 08 2002 Marc Boucher
	- hcflinmodem.spec.in: only run hcfconfig --auto in %post if
	HCF_AUTOCONFIG env variable is set, so as to match INSTALL documentation.
	- modules/serial_hcf.c: PCI vendor and device IDs of HCF modem can be
	explicitely passed as modules parameters named pcivendorid and pcideviceid.
	- T__ERROR messages always printk()ed when USE_TRACE_ONLY_ERRORS defined.
	- /devicemanager/asiclib.c: fixed crash upon SysCreateDevResources()
	failure due to AsicDisableHWEvent() being called.
	- modules/osspec/osservices.c: OsSleep() should call schedule_timeout()
	or mdelay(), not udelay().

* Tue Mar 05 2002 Marc Boucher
	- Released hcflinmodem-0.9mbsibeta02030500.

* Tue Mar 05 2002 Marc Boucher
	- Added "Conflicts: hsflinmodem" to RPM spec file as a temporary
	measure until the symbol name collisions are fixed.
	- scripts/hcfconfig.in: get_inf_section(): redirect stderr to /dev/null
	for the preprocess_inf() call to ignore broken pipe errors.

* Fri Mar 01 2002 Marc Boucher
	- Initial beta version (hcflinmodem-0.9mbsibeta02030100).
